<template>
	<div class="my-container">
		<div class="bill-main">
			<module-view :propConfig="config" ref="moduleView" @pagination="getDataList" @search="getDataList"
				@resert="onRefresh" @clickHandle="clickHandle" @detail="openEdit" @onRefresh="onRefresh">
			</module-view>
		</div>
		<!-- 新增/编辑弹窗 -->
		<el-dialog :title="popTitle+'品牌'" :visible.sync="dialogFormVisible" width="30%">
			<by-form :propConfig="addConfig" ref="addFormId">
				<template v-slot:status class="clearfix">
					<el-radio class="fl" style="margin-top: 8px;" v-model="radio" :label="0">正常</el-radio>
					<el-radio class="fl" style="margin-top: 8px;" v-model="radio" :label="1">禁用</el-radio>
				</template>
			</by-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="dialogFormVisible = false">取 消</el-button>
				<el-button type="primary" @click="confirm">确 定</el-button>
			</div>
		</el-dialog>
	</div>
</template>
<script lang="ts">
	import { Component, Prop, Vue, Watch } from "vue-property-decorator";
	// import Parent from "@/components/Parent/Parent";
	import api from "@/api/currency";
	import Assembly from "@/components/Assembly/material.vue";
	@Component
	export default class Brand extends Vue {
		timeNum = 0;
		timer : any = null
		popTitle : any = ''
		radio : any = 0
		dialogFormVisible : boolean = false
		config : any = {
			attr:{
				calculateH:true
			},
			search: {
				attr: {
					size: 'mini',
				},
				columns: [
					[{
						span: 6,
						label: '名称',
						prop: 'name',
						component: 'by-input',
						labelWidth: '70px',
						compConfig: {
							attr: {
								placeholder: '请输入名称',
								clearable: true
							},
						},
					}, {
						span: 6,
						label: '简称',
						prop: 'shortName',
						component: 'by-input',
						labelWidth: '70px',
						compConfig: {
							attr: {
								placeholder: '请输入简称',
								clearable: true
							}
						}
					},
					{
						span: 6,
						label: '状态',
						prop: 'status',
						labelWidth: '70px',
						component: 'by-select',
						compConfig: {
							attr: {
								placeholder: '请选择状态',
								clearable: true,
								size: 'small',
								data: [{
									value: 0,
									label: '正常'
								}, {
									value: 1,
									label: '禁用'
								}]
							}
						}
					},
					]
				]
			},
			tool: {
				tools: {
					add: true,
					delete: true,
					search: true,
					refresh: true
				}
			},
			table: {
				attr: {
					size: 'mini',
					align: 'left',
					checkbox: true,
				},
				columns: [{
					title: '名称',
					field: 'name',
					isDetail: true,
					width: 300,
				}, {
					title: '简称',
					field: 'shortName',
					width: 300,
				},
				{
					width: 500,
					title: '备注',
					field: 'remark',
				},
				{
					width: 80,
					title: '状态',
					field: 'status',
					align: 'center',
					component: Assembly,
				},
				{
					width: 120,
					title: '操作',
					action: true,
					plugins: [{
						icon: 'el-icon-edit',
						name: '编辑',
						audit: '',
						event: {
							click: (item : any) => {
								(this as any).openEdit(item)
							}
						}
					}, {
						name: '删除',
						event: {
							click: (item : any) => (this as any).doDelete(item)
						}
					}]
				}]
			},
		}
		addConfig = {
			attr: {
				size: 'small',
				rules: {
					name: [{
						required: true, message: '请输入名称', trigger: 'blur'
					}],
					shortName: [{
						required: true, message: '请输入简称', trigger: 'blur'
					}]
				}
			},
			columns: [
				[
					{
						span: 23,
						labelWidth: '70px',
						label: '名称',
						prop: 'name',
						component: 'by-input',
					},
					{
						span: 23,
						labelWidth: '70px',
						label: '简称',
						prop: 'shortName',
						component: 'by-input',
					},
					{
						span: 23,
						labelWidth: '70px',
						label: '状态',
						slot: true,
						prop: 'status',
					},
				],
				[
					{
						span: 23,
						labelWidth: '70px',
						label: '备注',
						prop: 'remark',
						component: 'by-input',
						compConfig: {
							attr: {
								size: 'mini',
								placeholder: '请输入备注',
								type: 'textarea'
							},
						}
					},
				]
			]
		}
		mounted() {
			this.timer = setInterval(() => {
				this.getDataList()
			}, 300)
		}
		// 确认新增/编辑
		confirm() {
			(this as any).$refs.addFormId.validate().then(() => {
				let query = (this as any).$refs.addFormId.getValue();
				// console.log(query);
				query.status = this.radio;
				this.dialogFormVisible = false;
				if (this.popTitle === '新增') {
					api.saveList(query, 'maindataMaterialBrand').then((res : any) => {
						if (res.code === 200) {
							this.$message.success('新增成功');
							this.getDataList();
						} else this.$message.error(res.msg);
					}).catch(() => {});
				} else if (this.popTitle === '编辑') {
					api.updateList(query, 'maindataMaterialBrand').then((res : any) => {
						if (res.code === 200) {
							this.$message.success('编辑成功');
							this.getDataList();
						} else this.$message.error(res.msg);
					}).catch(() => {});
				}
			}).catch(() => {});
		}
		// 获取列表数据
		getDataList() {
			if (!this.$refs.moduleView) {
				if (this.timeNum > 5) {
					clearInterval(this.timer)
				}
				this.timeNum++;
				return
			}
			clearInterval(this.timer)
			let query = (this.$refs.moduleView as any).getQuery();
			this.getPageList(query);
		}
		getPageList(query : any) {
			let loading = this.$loading({ target: '.main-container' });
			api.pageList(query, 'maindataMaterialBrand').then((res : any) => {
				loading.close();
				if (res.code === 200) {
					(this.$refs.moduleView as any).setTableValue(res.data.records);
					let page = {
						pageNo: res.data.current, //当前页
						pageSize: res.data.size, //每页条数
						total: res.data.total //总条数
					};
					(this.$refs.moduleView as any).setPage(page);
				} else this.$message.error(res.msg);
			}).catch(() => loading.close());
		}
		// 工具栏方法
		clickHandle(e : any) {
			if (e === 'onAdd') this.onAdd();
			if (e === 'onDelete') this.onDelete();
		}
		// 打开新增
		onAdd() {
			this.popTitle = '新增';
			this.dialogFormVisible = true;
			this.radio = 0;
			this.$nextTick(() => (this as any).$refs.addFormId.setValue());
		}
		// 打开编辑
		openEdit(e : any) {
			this.popTitle = '编辑';
			let loading = this.$loading({ target: '.main-container' });
			api.single({ id: e.id }, 'maindataMaterialBrand').then((res : any) => {
				loading.close();
				if (res.code === 200) {
					let data = res.data;
					this.dialogFormVisible = true;
					this.radio = data.status;
					this.$nextTick(() => (this as any).$refs.addFormId.setValue(data));
				}
			}).catch(() => loading.close());
		}
		// 工具栏删除
		onDelete() {
			let selectData = (this.$refs.moduleView as any).getSelectData()
			let ids = '';
			if (selectData.length > 0) {
				selectData.map((v : any) => {
					ids += v.id + ','
				})
			} else return this.$message.warning('请选择删除数据');
			ids = ids.slice(0, ids.length - 1);
			this.$confirm('确定删除吗,此操作不能撤销！', '注意', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
				center: true
			}).then(() => {
				api.deleteList({ ids: ids }, 'maindataMaterialBrand').then((res : any) => {
					if (res.code === 200) {
						this.getDataList();
						this.$message.success('删除成功');
					} else this.$message.error(res.msg);
				}).catch(() => {});
			}).catch(() => this.$message.info('已取消删除'));
		}
		// 操作删除
		doDelete(item : any) {
			this.$confirm('确定删除吗,此操作不能撤销！', '注意', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
				center: true
			}).then(() => {
				api.deleteList({ ids: item.id }, 'maindataMaterialBrand').then((res : any) => {
					if (res.code === 200) {
						this.getDataList();
						this.$message.success('删除成功');
					} else this.$message.error(res.msg);
				}).catch(() => {});
			}).catch(() => this.$message.info('已取消删除'));
		}
		// 刷新/重置
		onRefresh() {
			(this as any).$refs.moduleView.clearSearch();
			this.getDataList();
		}
	}
</script>
<style lang="scss" scoped>
	.my-container {
		width: 100%;
		box-sizing: border-box;
		display: flex;
		padding: 16px;
		height: 100%;
		.bill-left {
			position: relative;
			border-right: solid #EEE 1px;
			flex-shrink: 0;
			.bill-tab {
				width: 150px;
				height: 100%;
				transition: all .5s;
				overflow: hidden;
			}
			.tab-title {
				font-size: 16px;
				padding-bottom: 16px;
				width: 200px;
			}
		}
		.bill-main {
			width: 100%;
			box-sizing: border-box;
			position: relative;
			height: 100%;
			overflow-y: hidden;
		}
	}
</style>